local _, addon = ...

-- functions
local setmetatable = setmetatable
-- constants
-- frames
-- libs

local proxy
local metatable = {
    __index = function(self, key)
        local value = proxy[key]
        return value
    end,
    __newindex = function(self, key, value)
        local old = proxy[key]
        proxy[key] = value
        addon:Fire(addon.EVENT_OPTION_CHANGED, key, value, old)
    end,
}

addon:RegisterCallback(addon.EVENT_INITIALISED, function()
    addon.db.options = addon.db.options or {}

    proxy = addon.db.options
    addon.options = setmetatable({}, metatable)

    if addon.options.debug == nil then
        addon.options.debug = false
    end

    if addon.options.useShorthand == nil then
        addon.options.useShorthand = false
    end

    if addon.options.showRecords == nil then
        addon.options.showRecords = true
    end

    if addon.options.anonymiseCharacters == nil then
        addon.options.anonymiseCharacters = true
    end
end)
